<?php

require_once dirname(__FILE__).'/../lib/repozytoriumGeneratorConfiguration.class.php';
require_once dirname(__FILE__).'/../lib/repozytoriumGeneratorHelper.class.php';

/**
 * repozytorium actions.
 *
 * @package    sam3
 * @subpackage repozytorium
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class repozytoriumActions extends autoRepozytoriumActions
{

    public function preExecute()
    {
        if(!in_array('repo', ModulPeer::getEnabled()))
            $this->forward404();
        
        $this->configuration = new repozytoriumGeneratorConfiguration();

        if(!$this->getUser()->hasCredential($this->configuration->getCredentials($this->getActionName())))
        {
            $this->forward(sfConfig::get('sf_secure_module'), sfConfig::get('sf_secure_action'));
        }

        $this->dispatcher->notify(new sfEvent($this, 'admin.pre_execute', array('configuration' => $this->configuration)));

        $this->helper = new repozytoriumGeneratorHelper();
    }

    protected function processForm(sfWebRequest $request, sfForm $form)
    {
        $params = $request->getParameter($form->getName());
        $files = $request->getFiles($form->getName());

        if(!empty($files) && !empty($files['sciezka']) && $files['sciezka']['error'] == 0)
        {
            $file_name = $files['sciezka']['name'];
            $file_size = $files['sciezka']['size'];
            $file_ext = substr($file_name, strrpos($file_name, '.') + 1);

            $params['nazwa_pliku'] = md5($file_name).'_'.md5($params['created_at']).'.'.$file_ext;
            $params['nazwa_org'] = $file_name;
            $params['rozmiar_pliku'] = $file_size;
            $params['format_pliku'] = $file_ext;
            $params['mime_type'] = $files['sciezka']['type'];
            if(empty($params['nazwa']))
                $params['nazwa'] = substr($file_name, 0, strrpos($file_name, '.'));

            if(empty($params['opis']))
                $params['opis'] = $file_name.' ('.$files['sciezka']['type'].')';

            if(!move_uploaded_file($files['sciezka']['tmp_name'], sfConfig::get('sf_upload_dir').'/repozytorium/'.$params['nazwa_pliku']))
                throw new RuntimeException('Failed to move uploaded file.');

            //$params['sciezka'] = '/uploads/repozytorium/';

            /**/
            try
            {
                $is_image = is_array(@getimagesize($abs_path));
                
                if($is_image)
                {
                    $allow_fopen = ini_get('allow_url_fopen');
                    if(!$allow_fopen)
                        throw new Exception('Nie udało się połączyć z usługą OCR.sam3.pl');
                    $ocr_content = @file_get_contents('http://ocr.sam3.pl/ocr.php?img='.$request->getUriPrefix().'/uploads/repozytorium/'.$params['nazwa_pliku']);
                    if($ocr_content === false)
                        throw new Exception('Nie udało się połączyć z usługą OCR.sam3.pl');
                    $params['tresc_pliku'] = $ocr_content;
                }

                if($files['sciezka']['type'] == 'application/pdf')
                {
                    $allow_fopen = ini_get('allow_url_fopen');
                    if(!$allow_fopen)
                        throw new Exception('Nie udało się połączyć z usługą OCR.sam3.pl');
                    $ocr_content = @file_get_contents('http://ocr.sam3.pl/ocr.php?pdf='.$request->getUriPrefix().'/uploads/repozytorium/'.$params['nazwa_pliku']);
                    if($ocr_content === false)
                        throw new Exception('Nie udało się połączyć z usługą OCR.sam3.pl');
                    $params['tresc_pliku'] = $ocr_content;
                }
            }
            catch (Exception $e)
            {
                $this->getUser()->setFlash('info', $e->getMessage());
            }
            /**/
        }
        elseif(array_key_exists('sciezka', $files) && array_key_exists('error', $files['sciezka']))
        {
            switch ($files['sciezka']['error'])
            {
                case UPLOAD_ERR_OK:
                    break;
                case UPLOAD_ERR_NO_FILE:
                    unset($files['sciezka']);
                    break;
                //throw new RuntimeException('No file sent.');
                case UPLOAD_ERR_INI_SIZE:
                case UPLOAD_ERR_FORM_SIZE:
                    throw new RuntimeException('Exceeded filesize limit.');
                default:
                    throw new RuntimeException('Unknown errors.');
            }
        }

        if(!$form->getObject()->isNew() && array_key_exists('sciezka', $params))
            unlink(sfConfig::get('sf_upload_dir').'/repozytorium/'.$form->getObject()->getNazwaPliku());

        $form->bind($params, $files);
        if($form->isValid())
        {
            $notice = $form->getObject()->isNew() ? 'The item was created successfully.' : 'The item was updated successfully.';

            $repozytorium = $form->save();

            $this->dispatcher->notify(new sfEvent($this, 'admin.save_object', array('object' => $repozytorium)));

            if($request->hasParameter('_save_and_add'))
            {
                $this->getUser()->setFlash('notice', $notice.' You can add another one below.');

                $this->redirect('@repozytorium_new');
            }
            else
            {
                $this->getUser()->setFlash('notice', $notice);

                $this->redirect(array('sf_route' => 'repozytorium_edit', 'sf_subject' => $repozytorium));
            }
        }
        else
        {
            $this->getUser()->setFlash('error', 'The item has not been saved due to some errors.', false);
        }
    }

    public function executeSkasuj(sfWebRequest $request)
    {
        $id = $request->getParameter('id');
        $file = RepozytoriumPeer::retrieveByPK($id);
        $this->forward404Unless($file, 'Ten plik nie istnieje');

        $file->delete();
        $this->getUser()->setFlash('notice', 'Plik został skasowany');
        $this->redirect('repozytorium');
    }

}