<?php include_stylesheets_for_form($form) ?>
<?php include_javascripts_for_form($form) ?>

<div class="sf_admin_form">
    <?php echo form_tag_for($form, '@repozytorium', array('name' => 'repozytorium_form')) ?>
    <?php echo $form->renderHiddenFields() ?>

    <ul class="error_list">
        <?php foreach($form->getErrorsNice() as $key => $value): ?>
            <li><?php echo $key ?>. <?php echo $value ?></li>
        <?php endforeach; ?>
    </ul>

    <div class="cl"></div>

    <?php foreach($configuration->getFormFields($form, $form->isNew() ? 'new' : 'edit') as $fieldset => $fields): ?>
        <?php include_partial('repozytorium/form_fieldset', array('repozytorium' => $repozytorium, 'form' => $form, 'fields' => $fields, 'fieldset' => $fieldset)) ?>
    <?php endforeach; ?>

    <?php if(!$form->isNew()): ?>
    <fieldset id="sf_fieldset_<?php echo preg_replace('/[^a-z0-9_]/', '_', strtolower($fieldset)) ?>" class="editor">

        <legend><?php echo __('Osadzenie'); ?></legend>

        <table cellspacing="4" cellpadding="0">
            <tr>
                <td class="label_right" style="width: 160px;"><?php echo __('Link pobierania') ?>:</td>        
                <td>
                    <div style="border: 1px solid silver; padding: 10px;">
                        <?php echo $form->getObject()->getHtmlLink(); ?>                        
                    </div>
                </td>
            </tr>
            <tr>
                <td class="label_right" style="width: 160px;"><?php echo __('Kod pobierania') ?>:</td>        
                <td>
                    <div style="border: 1px solid silver; padding: 10px;">
                        <?php echo htmlentities($form->getObject()->getHtmlLink()); ?>
                    </div>
                </td>
            </tr>
        </table>
    </fieldset>
    <?php endif; ?>

    <div style="float: right;">
        <?php include_partial('repozytorium/form_actions', array('repozytorium' => $repozytorium, 'form' => $form, 'configuration' => $configuration, 'helper' => $helper)) ?>
    </div>
</form>
</div>
