<?php

require_once(sfConfig::get('sf_lib_dir').'/filter/base/BaseFormFilterPropel.class.php');

/**
 * Repozytorium filter form base class.
 *
 * @package    sam3
 * @subpackage filter
 * @author     Your name here
 */
class BaseRepozytoriumFormFilter extends BaseFormFilterPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'portal_id'                       => new sfWidgetFormPropelChoice(array('model' => 'Portal', 'add_empty' => true)),
      'sciezka'                         => new sfWidgetFormFilterInput(),
      'nazwa_pliku'                     => new sfWidgetFormFilterInput(),
      'nazwa_org'                       => new sfWidgetFormFilterInput(),
      'rozmiar_pliku'                   => new sfWidgetFormFilterInput(),
      'format_pliku'                    => new sfWidgetFormFilterInput(),
      'mime_type'                       => new sfWidgetFormFilterInput(),
      'tresc_pliku'                     => new sfWidgetFormFilterInput(),
      'nazwa'                           => new sfWidgetFormFilterInput(),
      'opis'                            => new sfWidgetFormFilterInput(),
      'ilosc_pobran'                    => new sfWidgetFormFilterInput(),
      'ilosc_dowiazan'                  => new sfWidgetFormFilterInput(),
      'created_at'                      => new sfWidgetFormFilterDate(array('from_date' => new sfWidgetFormDate(), 'to_date' => new sfWidgetFormDate(), 'with_empty' => true)),
      'updated_at'                      => new sfWidgetFormFilterDate(array('from_date' => new sfWidgetFormDate(), 'to_date' => new sfWidgetFormDate(), 'with_empty' => true)),
      'repozytorium_kategoria_map_list' => new sfWidgetFormPropelChoice(array('model' => 'RepozytoriumKategoria', 'add_empty' => true)),
      'repozytorium_modul_map_list'     => new sfWidgetFormPropelChoice(array('model' => 'Modul', 'add_empty' => true)),
    ));

    $this->setValidators(array(
      'portal_id'                       => new sfValidatorPropelChoice(array('required' => false, 'model' => 'Portal', 'column' => 'id')),
      'sciezka'                         => new sfValidatorPass(array('required' => false)),
      'nazwa_pliku'                     => new sfValidatorPass(array('required' => false)),
      'nazwa_org'                       => new sfValidatorPass(array('required' => false)),
      'rozmiar_pliku'                   => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
      'format_pliku'                    => new sfValidatorPass(array('required' => false)),
      'mime_type'                       => new sfValidatorPass(array('required' => false)),
      'tresc_pliku'                     => new sfValidatorPass(array('required' => false)),
      'nazwa'                           => new sfValidatorPass(array('required' => false)),
      'opis'                            => new sfValidatorPass(array('required' => false)),
      'ilosc_pobran'                    => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
      'ilosc_dowiazan'                  => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
      'created_at'                      => new sfValidatorDateRange(array('required' => false, 'from_date' => new sfValidatorDate(array('required' => false)), 'to_date' => new sfValidatorDate(array('required' => false)))),
      'updated_at'                      => new sfValidatorDateRange(array('required' => false, 'from_date' => new sfValidatorDate(array('required' => false)), 'to_date' => new sfValidatorDate(array('required' => false)))),
      'repozytorium_kategoria_map_list' => new sfValidatorPropelChoice(array('model' => 'RepozytoriumKategoria', 'required' => false)),
      'repozytorium_modul_map_list'     => new sfValidatorPropelChoice(array('model' => 'Modul', 'required' => false)),
    ));

    $this->widgetSchema->setNameFormat('repozytorium_filters[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function addRepozytoriumKategoriaMapListColumnCriteria(Criteria $criteria, $field, $values)
  {
    if (!is_array($values))
    {
      $values = array($values);
    }

    if (!count($values))
    {
      return;
    }

    $criteria->addJoin(RepozytoriumKategoriaMapPeer::REPOZYTORIUM_ID, RepozytoriumPeer::ID);

    $value = array_pop($values);
    $criterion = $criteria->getNewCriterion(RepozytoriumKategoriaMapPeer::REPOZYTORIUM_KATEGORIA_ID, $value);

    foreach ($values as $value)
    {
      $criterion->addOr($criteria->getNewCriterion(RepozytoriumKategoriaMapPeer::REPOZYTORIUM_KATEGORIA_ID, $value));
    }

    $criteria->add($criterion);
  }

  public function addRepozytoriumModulMapListColumnCriteria(Criteria $criteria, $field, $values)
  {
    if (!is_array($values))
    {
      $values = array($values);
    }

    if (!count($values))
    {
      return;
    }

    $criteria->addJoin(RepozytoriumModulMapPeer::REPOZYTORIUM_ID, RepozytoriumPeer::ID);

    $value = array_pop($values);
    $criterion = $criteria->getNewCriterion(RepozytoriumModulMapPeer::MODUL_ID, $value);

    foreach ($values as $value)
    {
      $criterion->addOr($criteria->getNewCriterion(RepozytoriumModulMapPeer::MODUL_ID, $value));
    }

    $criteria->add($criterion);
  }

  public function getModelName()
  {
    return 'Repozytorium';
  }

  public function getFields()
  {
    return array(
      'id'                              => 'Number',
      'portal_id'                       => 'ForeignKey',
      'sciezka'                         => 'Text',
      'nazwa_pliku'                     => 'Text',
      'nazwa_org'                       => 'Text',
      'rozmiar_pliku'                   => 'Number',
      'format_pliku'                    => 'Text',
      'mime_type'                       => 'Text',
      'tresc_pliku'                     => 'Text',
      'nazwa'                           => 'Text',
      'opis'                            => 'Text',
      'ilosc_pobran'                    => 'Number',
      'ilosc_dowiazan'                  => 'Number',
      'created_at'                      => 'Date',
      'updated_at'                      => 'Date',
      'repozytorium_kategoria_map_list' => 'ManyKey',
      'repozytorium_modul_map_list'     => 'ManyKey',
    );
  }
}
