<?php

require_once(sfConfig::get('sf_lib_dir').'/filter/base/BaseFormFilterPropel.class.php');

/**
 * RepozytoriumKategoria filter form base class.
 *
 * @package    sam3
 * @subpackage filter
 * @author     Your name here
 */
class BaseRepozytoriumKategoriaFormFilter extends BaseFormFilterPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'portal_id'                       => new sfWidgetFormPropelChoice(array('model' => 'Portal', 'add_empty' => true)),
      'nazwa'                           => new sfWidgetFormFilterInput(),
      'opis'                            => new sfWidgetFormFilterInput(),
      'widoczna'                        => new sfWidgetFormFilterInput(),
      'kolejnosc'                       => new sfWidgetFormFilterInput(),
      'created_at'                      => new sfWidgetFormFilterDate(array('from_date' => new sfWidgetFormDate(), 'to_date' => new sfWidgetFormDate(), 'with_empty' => true)),
      'updated_at'                      => new sfWidgetFormFilterDate(array('from_date' => new sfWidgetFormDate(), 'to_date' => new sfWidgetFormDate(), 'with_empty' => true)),
      'repozytorium_kategoria_map_list' => new sfWidgetFormPropelChoice(array('model' => 'Repozytorium', 'add_empty' => true)),
    ));

    $this->setValidators(array(
      'portal_id'                       => new sfValidatorPropelChoice(array('required' => false, 'model' => 'Portal', 'column' => 'id')),
      'nazwa'                           => new sfValidatorPass(array('required' => false)),
      'opis'                            => new sfValidatorPass(array('required' => false)),
      'widoczna'                        => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
      'kolejnosc'                       => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
      'created_at'                      => new sfValidatorDateRange(array('required' => false, 'from_date' => new sfValidatorDate(array('required' => false)), 'to_date' => new sfValidatorDate(array('required' => false)))),
      'updated_at'                      => new sfValidatorDateRange(array('required' => false, 'from_date' => new sfValidatorDate(array('required' => false)), 'to_date' => new sfValidatorDate(array('required' => false)))),
      'repozytorium_kategoria_map_list' => new sfValidatorPropelChoice(array('model' => 'Repozytorium', 'required' => false)),
    ));

    $this->widgetSchema->setNameFormat('repozytorium_kategoria_filters[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function addRepozytoriumKategoriaMapListColumnCriteria(Criteria $criteria, $field, $values)
  {
    if (!is_array($values))
    {
      $values = array($values);
    }

    if (!count($values))
    {
      return;
    }

    $criteria->addJoin(RepozytoriumKategoriaMapPeer::REPOZYTORIUM_KATEGORIA_ID, RepozytoriumKategoriaPeer::ID);

    $value = array_pop($values);
    $criterion = $criteria->getNewCriterion(RepozytoriumKategoriaMapPeer::REPOZYTORIUM_ID, $value);

    foreach ($values as $value)
    {
      $criterion->addOr($criteria->getNewCriterion(RepozytoriumKategoriaMapPeer::REPOZYTORIUM_ID, $value));
    }

    $criteria->add($criterion);
  }

  public function getModelName()
  {
    return 'RepozytoriumKategoria';
  }

  public function getFields()
  {
    return array(
      'id'                              => 'Number',
      'portal_id'                       => 'ForeignKey',
      'nazwa'                           => 'Text',
      'opis'                            => 'Text',
      'widoczna'                        => 'Number',
      'kolejnosc'                       => 'Number',
      'created_at'                      => 'Date',
      'updated_at'                      => 'Date',
      'repozytorium_kategoria_map_list' => 'ManyKey',
    );
  }
}
