<?php

/**
 * Repozytorium form.
 *
 * @package    sam3
 * @subpackage form
 * @author     Your name here
 */
class RepozytoriumForm extends BaseRepozytoriumForm
{

    public function configure()
    {
        $rel_path = $this->isNew() ? null : '/uploads/repozytorium/'.$this->getObject()->getNazwaPliku();
        $abs_path = str_replace('/uploads/', sfConfig::get('sf_upload_dir').'/', $rel_path);
        
        $category_crit = new Criteria();
        $category_crit->add(RepozytoriumKategoriaPeer::WIDOCZNA, 1);
        $category_crit->addAscendingOrderByColumn(RepozytoriumKategoriaPeer::KOLEJNOSC);
        
        $image_check = is_array(@getimagesize($abs_path));
        $is_image = !$this->isNew() && $image_check;
        
        //  WIDGETS  -----------------------------------------------------------
        $this->setWidget('portal_id', new sfWidgetFormInputHidden());
        $this->setWidget('sciezka', new sfWidgetFormInputFileEditable(array('file_src' => $rel_path, 'with_delete' => false, 'is_image' => $is_image), array('class' => 'required', 'style' => 'width: 500px;')));
        $this->setWidget('nazwa_pliku', new sfWidgetFormInputHidden());
        $this->setWidget('nazwa_org', new sfWidgetFormInputHidden());
        $this->setWidget('rozmiar_pliku', new sfWidgetFormInputHidden());
        $this->setWidget('format_pliku', new sfWidgetFormInputHidden());
        $this->setWidget('mime_type', new sfWidgetFormInputHidden());
        $this->setWidget('tresc_pliku', new sfWidgetFormInputHidden());
        $this->setWidget('nazwa', new sfWidgetFormInput(array(), array('class' => 'required', 'style' => 'width: 500px;')));
        $this->setWidget('opis', new sfWidgetFormTextarea(array(), array('style' => 'width: 500px;')));
        $this->setWidget('ilosc_pobran', new sfWidgetFormInput(array(), array('readonly' => true)));
        $this->setWidget('ilosc_dowiazan', new sfWidgetFormInput(array(), array('readonly' => true)));
        $this->setWidget('created_at', new sfWidgetFormInputHidden());
        $this->setWidget('updated_at', new sfWidgetFormInputHidden());        
        $this->setWidget('repozytorium_kategoria_map_list', new sfWidgetFormPropelChoiceMany(array('model' => 'RepozytoriumKategoria', 'criteria' => $category_crit, 'expanded' => true)));
        
        //  LABELS  ------------------------------------------------------------
        $this->widgetSchema->setLabel('sciezka', 'Plik');
        $this->widgetSchema->setLabel('repozytorium_kategoria_map_list', 'Kategorie');
        $this->widgetSchema->setLabel('ilosc_pobran', 'Ilość pobrań');
        $this->widgetSchema->setLabel('ilosc_dowiazan', 'Ilość dowiązań');
        
        //  DEFAULTS  ----------------------------------------------------------
        $this->setDefault('portal_id', sfConfig::get('portal')->getId());
        if($this->isNew())
            $this->setDefault('created_at', date('Y-m-d H:i:s'));
        else
            $this->setDefault('updated_at', date('Y-m-d H:i:s'));
        
        //  VALIDATORS  --------------------------------------------------------
        $this->setValidator('sciezka', new sfValidatorFile(array('max_size' => 8*1024*1024, 'path' => sfConfig::get('sf_upload_dir').'/repozytorium', 'required' => false), array('invalid' => 'Pole niepoprawne', 'max_size' => 'Max 8 MB')));
        $this->setValidator('sciezka_delete', new sfValidatorPass());
            
        //  HELPS  -------------------------------------------------------------
        $this->widgetSchema->setHelp('sciezka', 'Wskaż plik do wgrania na repozytorium');
        $this->widgetSchema->setHelp('nazwa', 'Wyświetlana nazwa pliku zostanie zczytana z pliku podczas wgrywania do repozytorium');
        $this->widgetSchema->setHelp('opis', 'Dodatkowy opis pliku, pojawiający się "w dymku"');
        $this->widgetSchema->setHelp('ilosc_pobran', 'Ilość pobrań przez internautów');
        $this->widgetSchema->setHelp('ilosc_dowiazan', 'Ilość dowiązanych artykułów');
        $this->widgetSchema->setHelp('repozytorium_kategoria_map_list', 'Przypisz odpowiednie kategorie do tego pliku');
        
        //  OTHER  -------------------------------------------------------------
        unset($this->widgetSchema['repozytorium_modul_map_list']);
        $this->getWidgetSchema()->getFormFormatter()->setHelpFormat('%help%');
    }

}