<?php

/**
 * Repozytorium form base class.
 *
 * @package    sam3
 * @subpackage form
 * @author     Your name here
 */
class BaseRepozytoriumForm extends BaseFormPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'id'                              => new sfWidgetFormInputHidden(),
      'portal_id'                       => new sfWidgetFormPropelChoice(array('model' => 'Portal', 'add_empty' => false)),
      'sciezka'                         => new sfWidgetFormInput(),
      'nazwa_pliku'                     => new sfWidgetFormInput(),
      'nazwa_org'                       => new sfWidgetFormInput(),
      'rozmiar_pliku'                   => new sfWidgetFormInput(),
      'format_pliku'                    => new sfWidgetFormInput(),
      'mime_type'                       => new sfWidgetFormInput(),
      'tresc_pliku'                     => new sfWidgetFormTextarea(),
      'nazwa'                           => new sfWidgetFormInput(),
      'opis'                            => new sfWidgetFormTextarea(),
      'ilosc_pobran'                    => new sfWidgetFormInput(),
      'ilosc_dowiazan'                  => new sfWidgetFormInput(),
      'created_at'                      => new sfWidgetFormDateTime(),
      'updated_at'                      => new sfWidgetFormDateTime(),
      'repozytorium_kategoria_map_list' => new sfWidgetFormPropelChoiceMany(array('model' => 'RepozytoriumKategoria')),
      'repozytorium_modul_map_list'     => new sfWidgetFormPropelChoiceMany(array('model' => 'Modul')),
    ));

    $this->setValidators(array(
      'id'                              => new sfValidatorPropelChoice(array('model' => 'Repozytorium', 'column' => 'id', 'required' => false)),
      'portal_id'                       => new sfValidatorPropelChoice(array('model' => 'Portal', 'column' => 'id')),
      'sciezka'                         => new sfValidatorString(array('max_length' => 255)),
      'nazwa_pliku'                     => new sfValidatorString(array('max_length' => 255)),
      'nazwa_org'                       => new sfValidatorString(array('max_length' => 255)),
      'rozmiar_pliku'                   => new sfValidatorInteger(),
      'format_pliku'                    => new sfValidatorString(array('max_length' => 255)),
      'mime_type'                       => new sfValidatorString(array('max_length' => 255)),
      'tresc_pliku'                     => new sfValidatorString(array('required' => false)),
      'nazwa'                           => new sfValidatorString(array('max_length' => 255)),
      'opis'                            => new sfValidatorString(array('required' => false)),
      'ilosc_pobran'                    => new sfValidatorInteger(array('required' => false)),
      'ilosc_dowiazan'                  => new sfValidatorInteger(array('required' => false)),
      'created_at'                      => new sfValidatorDateTime(array('required' => false)),
      'updated_at'                      => new sfValidatorDateTime(array('required' => false)),
      'repozytorium_kategoria_map_list' => new sfValidatorPropelChoiceMany(array('model' => 'RepozytoriumKategoria', 'required' => false)),
      'repozytorium_modul_map_list'     => new sfValidatorPropelChoiceMany(array('model' => 'Modul', 'required' => false)),
    ));

    $this->widgetSchema->setNameFormat('repozytorium[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'Repozytorium';
  }


  public function updateDefaultsFromObject()
  {
    parent::updateDefaultsFromObject();

    if (isset($this->widgetSchema['repozytorium_kategoria_map_list']))
    {
      $values = array();
      foreach ($this->object->getRepozytoriumKategoriaMaps() as $obj)
      {
        $values[] = $obj->getRepozytoriumKategoriaId();
      }

      $this->setDefault('repozytorium_kategoria_map_list', $values);
    }

    if (isset($this->widgetSchema['repozytorium_modul_map_list']))
    {
      $values = array();
      foreach ($this->object->getRepozytoriumModulMaps() as $obj)
      {
        $values[] = $obj->getModulId();
      }

      $this->setDefault('repozytorium_modul_map_list', $values);
    }

  }

  protected function doSave($con = null)
  {
    parent::doSave($con);

    $this->saveRepozytoriumKategoriaMapList($con);
    $this->saveRepozytoriumModulMapList($con);
  }

  public function saveRepozytoriumKategoriaMapList($con = null)
  {
    if (!$this->isValid())
    {
      throw $this->getErrorSchema();
    }

    if (!isset($this->widgetSchema['repozytorium_kategoria_map_list']))
    {
      // somebody has unset this widget
      return;
    }

    if (is_null($con))
    {
      $con = $this->getConnection();
    }

    $c = new Criteria();
    $c->add(RepozytoriumKategoriaMapPeer::REPOZYTORIUM_ID, $this->object->getPrimaryKey());
    RepozytoriumKategoriaMapPeer::doDelete($c, $con);

    $values = $this->getValue('repozytorium_kategoria_map_list');
    if (is_array($values))
    {
      foreach ($values as $value)
      {
        $obj = new RepozytoriumKategoriaMap();
        $obj->setRepozytoriumId($this->object->getPrimaryKey());
        $obj->setRepozytoriumKategoriaId($value);
        $obj->save();
      }
    }
  }

  public function saveRepozytoriumModulMapList($con = null)
  {
    if (!$this->isValid())
    {
      throw $this->getErrorSchema();
    }

    if (!isset($this->widgetSchema['repozytorium_modul_map_list']))
    {
      // somebody has unset this widget
      return;
    }

    if (is_null($con))
    {
      $con = $this->getConnection();
    }

    $c = new Criteria();
    $c->add(RepozytoriumModulMapPeer::REPOZYTORIUM_ID, $this->object->getPrimaryKey());
    RepozytoriumModulMapPeer::doDelete($c, $con);

    $values = $this->getValue('repozytorium_modul_map_list');
    if (is_array($values))
    {
      foreach ($values as $value)
      {
        $obj = new RepozytoriumModulMap();
        $obj->setRepozytoriumId($this->object->getPrimaryKey());
        $obj->setModulId($value);
        $obj->save();
      }
    }
  }

}
