<?php

/**
 * RepozytoriumKategoria form base class.
 *
 * @package    sam3
 * @subpackage form
 * @author     Your name here
 */
class BaseRepozytoriumKategoriaForm extends BaseFormPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'id'                              => new sfWidgetFormInputHidden(),
      'portal_id'                       => new sfWidgetFormPropelChoice(array('model' => 'Portal', 'add_empty' => false)),
      'nazwa'                           => new sfWidgetFormInput(),
      'opis'                            => new sfWidgetFormTextarea(),
      'widoczna'                        => new sfWidgetFormInput(),
      'kolejnosc'                       => new sfWidgetFormInput(),
      'created_at'                      => new sfWidgetFormDateTime(),
      'updated_at'                      => new sfWidgetFormDateTime(),
      'repozytorium_kategoria_map_list' => new sfWidgetFormPropelChoiceMany(array('model' => 'Repozytorium')),
    ));

    $this->setValidators(array(
      'id'                              => new sfValidatorPropelChoice(array('model' => 'RepozytoriumKategoria', 'column' => 'id', 'required' => false)),
      'portal_id'                       => new sfValidatorPropelChoice(array('model' => 'Portal', 'column' => 'id')),
      'nazwa'                           => new sfValidatorString(array('max_length' => 255)),
      'opis'                            => new sfValidatorString(array('required' => false)),
      'widoczna'                        => new sfValidatorInteger(),
      'kolejnosc'                       => new sfValidatorInteger(array('required' => false)),
      'created_at'                      => new sfValidatorDateTime(array('required' => false)),
      'updated_at'                      => new sfValidatorDateTime(array('required' => false)),
      'repozytorium_kategoria_map_list' => new sfValidatorPropelChoiceMany(array('model' => 'Repozytorium', 'required' => false)),
    ));

    $this->widgetSchema->setNameFormat('repozytorium_kategoria[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'RepozytoriumKategoria';
  }


  public function updateDefaultsFromObject()
  {
    parent::updateDefaultsFromObject();

    if (isset($this->widgetSchema['repozytorium_kategoria_map_list']))
    {
      $values = array();
      foreach ($this->object->getRepozytoriumKategoriaMaps() as $obj)
      {
        $values[] = $obj->getRepozytoriumId();
      }

      $this->setDefault('repozytorium_kategoria_map_list', $values);
    }

  }

  protected function doSave($con = null)
  {
    parent::doSave($con);

    $this->saveRepozytoriumKategoriaMapList($con);
  }

  public function saveRepozytoriumKategoriaMapList($con = null)
  {
    if (!$this->isValid())
    {
      throw $this->getErrorSchema();
    }

    if (!isset($this->widgetSchema['repozytorium_kategoria_map_list']))
    {
      // somebody has unset this widget
      return;
    }

    if (is_null($con))
    {
      $con = $this->getConnection();
    }

    $c = new Criteria();
    $c->add(RepozytoriumKategoriaMapPeer::REPOZYTORIUM_KATEGORIA_ID, $this->object->getPrimaryKey());
    RepozytoriumKategoriaMapPeer::doDelete($c, $con);

    $values = $this->getValue('repozytorium_kategoria_map_list');
    if (is_array($values))
    {
      foreach ($values as $value)
      {
        $obj = new RepozytoriumKategoriaMap();
        $obj->setRepozytoriumKategoriaId($this->object->getPrimaryKey());
        $obj->setRepozytoriumId($value);
        $obj->save();
      }
    }
  }

}
