<?php

class Repozytorium extends BaseRepozytorium
{

    public function __toString()
    {
        return $this->getNazwa().'.'.$this->getFormatPliku();
    }

    /**
     * metoda zwracajaca link do pobierania tego pliku wraz z ikona i rozmiarem
     * @return      string kod HTML linku do pobrania zalacznika
     * @author      Tomasz Glowinski, 2015
     */
    public function getHtmlLink()
    {
        sfContext::getInstance()->getConfiguration()->loadHelpers(array('Asset', 'Url'));
        $uri_prefix = sfContext::getInstance()->getRequest()->getUriPrefix();
        
        $ext = $this->getFormatPliku();
        $icon_file = '/images/portal/ikony/'.strtolower($ext).'.png';
        if(file_exists(sfConfig::get('sf_web_dir').''.$icon_file))
            $icon = image_tag($uri_prefix.$icon_file, array('alt' => strtoupper($ext), 'style' => 'margin: 0 3px 0 0; vertical-align: bottom;'));
        else
            $icon = image_tag($uri_prefix.'/portal/ikony/default.png', array('alt' => '??', 'style' => 'margin: 0 3px 0 0; vertical-align: bottom;'));
        
        return link_to($icon.$this->getNazwa().'.'.$ext.' '.formatujRozmiar($this->getRozmiarPliku()), $uri_prefix.'/repozytorium-plik-'.$this->getId().'-'.Functions::slugify($this->getNazwa().'.'.$this->getFormatPliku()).'.html', array('target' => '_self', 'title' => $this->getOpis()));
    }

    /**
     * metoda zwiekszajaca ilosc pobran tego pliku
     * @author      Tomasz Glowinski, 2015
     */
    public function increaseDownloads()
    {
        $ilosc_pobran = $this->getIloscPobran() ? $this->setIloscPobran() : 0;
        $this->setIloscPobran($ilosc_pobran + 1);
        $this->save();
    }
}