<?php



class RepozytoriumMapBuilder implements MapBuilder {

	
	const CLASS_NAME = 'lib.model.map.RepozytoriumMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap(RepozytoriumPeer::DATABASE_NAME);

		$tMap = $this->dbMap->addTable(RepozytoriumPeer::TABLE_NAME);
		$tMap->setPhpName('Repozytorium');
		$tMap->setClassname('Repozytorium');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'INTEGER', true, null);

		$tMap->addForeignKey('PORTAL_ID', 'PortalId', 'INTEGER', 'portal', 'ID', true, 11);

		$tMap->addColumn('SCIEZKA', 'Sciezka', 'VARCHAR', true, 255);

		$tMap->addColumn('NAZWA_PLIKU', 'NazwaPliku', 'VARCHAR', true, 255);

		$tMap->addColumn('NAZWA_ORG', 'NazwaOrg', 'VARCHAR', true, 255);

		$tMap->addColumn('ROZMIAR_PLIKU', 'RozmiarPliku', 'INTEGER', true, 255);

		$tMap->addColumn('FORMAT_PLIKU', 'FormatPliku', 'VARCHAR', true, 255);

		$tMap->addColumn('MIME_TYPE', 'MimeType', 'VARCHAR', true, 255);

		$tMap->addColumn('TRESC_PLIKU', 'TrescPliku', 'LONGVARCHAR', false, null);

		$tMap->addColumn('NAZWA', 'Nazwa', 'VARCHAR', true, 255);

		$tMap->addColumn('OPIS', 'Opis', 'LONGVARCHAR', false, null);

		$tMap->addColumn('ILOSC_POBRAN', 'IloscPobran', 'INTEGER', false, 255);

		$tMap->addColumn('ILOSC_DOWIAZAN', 'IloscDowiazan', 'INTEGER', false, 255);

		$tMap->addColumn('CREATED_AT', 'CreatedAt', 'TIMESTAMP', false, null);

		$tMap->addColumn('UPDATED_AT', 'UpdatedAt', 'TIMESTAMP', false, null);

	} 
} 