<?php


abstract class BaseRepozytorium extends BaseObject  implements Persistent {


  const PEER = 'RepozytoriumPeer';

	
	protected static $peer;

	
	protected $id;

	
	protected $portal_id;

	
	protected $sciezka;

	
	protected $nazwa_pliku;

	
	protected $nazwa_org;

	
	protected $rozmiar_pliku;

	
	protected $format_pliku;

	
	protected $mime_type;

	
	protected $tresc_pliku;

	
	protected $nazwa;

	
	protected $opis;

	
	protected $ilosc_pobran;

	
	protected $ilosc_dowiazan;

	
	protected $created_at;

	
	protected $updated_at;

	
	protected $aPortal;

	
	protected $collRepozytoriumKategoriaMaps;

	
	private $lastRepozytoriumKategoriaMapCriteria = null;

	
	protected $collRepozytoriumModulMaps;

	
	private $lastRepozytoriumModulMapCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	
	public function applyDefaultValues()
	{
		$this->ilosc_pobran = 0;
		$this->ilosc_dowiazan = 0;
	}

	
	public function getId()
	{
		return $this->id;
	}

	
	public function getPortalId()
	{
		return $this->portal_id;
	}

	
	public function getSciezka()
	{
		return $this->sciezka;
	}

	
	public function getNazwaPliku()
	{
		return $this->nazwa_pliku;
	}

	
	public function getNazwaOrg()
	{
		return $this->nazwa_org;
	}

	
	public function getRozmiarPliku()
	{
		return $this->rozmiar_pliku;
	}

	
	public function getFormatPliku()
	{
		return $this->format_pliku;
	}

	
	public function getMimeType()
	{
		return $this->mime_type;
	}

	
	public function getTrescPliku()
	{
		return $this->tresc_pliku;
	}

	
	public function getNazwa()
	{
		return $this->nazwa;
	}

	
	public function getOpis()
	{
		return $this->opis;
	}

	
	public function getIloscPobran()
	{
		return $this->ilosc_pobran;
	}

	
	public function getIloscDowiazan()
	{
		return $this->ilosc_dowiazan;
	}

	
	public function getCreatedAt($format = 'Y-m-d H:i:s')
	{
		if ($this->created_at === null) {
			return null;
		}


		if ($this->created_at === '0000-00-00 00:00:00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->created_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->created_at, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function getUpdatedAt($format = 'Y-m-d H:i:s')
	{
		if ($this->updated_at === null) {
			return null;
		}


		if ($this->updated_at === '0000-00-00 00:00:00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->updated_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->updated_at, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function setId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = RepozytoriumPeer::ID;
		}

		return $this;
	} 
	
	public function setPortalId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->portal_id !== $v) {
			$this->portal_id = $v;
			$this->modifiedColumns[] = RepozytoriumPeer::PORTAL_ID;
		}

		if ($this->aPortal !== null && $this->aPortal->getId() !== $v) {
			$this->aPortal = null;
		}

		return $this;
	} 
	
	public function setSciezka($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->sciezka !== $v) {
			$this->sciezka = $v;
			$this->modifiedColumns[] = RepozytoriumPeer::SCIEZKA;
		}

		return $this;
	} 
	
	public function setNazwaPliku($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->nazwa_pliku !== $v) {
			$this->nazwa_pliku = $v;
			$this->modifiedColumns[] = RepozytoriumPeer::NAZWA_PLIKU;
		}

		return $this;
	} 
	
	public function setNazwaOrg($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->nazwa_org !== $v) {
			$this->nazwa_org = $v;
			$this->modifiedColumns[] = RepozytoriumPeer::NAZWA_ORG;
		}

		return $this;
	} 
	
	public function setRozmiarPliku($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->rozmiar_pliku !== $v) {
			$this->rozmiar_pliku = $v;
			$this->modifiedColumns[] = RepozytoriumPeer::ROZMIAR_PLIKU;
		}

		return $this;
	} 
	
	public function setFormatPliku($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->format_pliku !== $v) {
			$this->format_pliku = $v;
			$this->modifiedColumns[] = RepozytoriumPeer::FORMAT_PLIKU;
		}

		return $this;
	} 
	
	public function setMimeType($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->mime_type !== $v) {
			$this->mime_type = $v;
			$this->modifiedColumns[] = RepozytoriumPeer::MIME_TYPE;
		}

		return $this;
	} 
	
	public function setTrescPliku($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->tresc_pliku !== $v) {
			$this->tresc_pliku = $v;
			$this->modifiedColumns[] = RepozytoriumPeer::TRESC_PLIKU;
		}

		return $this;
	} 
	
	public function setNazwa($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->nazwa !== $v) {
			$this->nazwa = $v;
			$this->modifiedColumns[] = RepozytoriumPeer::NAZWA;
		}

		return $this;
	} 
	
	public function setOpis($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->opis !== $v) {
			$this->opis = $v;
			$this->modifiedColumns[] = RepozytoriumPeer::OPIS;
		}

		return $this;
	} 
	
	public function setIloscPobran($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->ilosc_pobran !== $v || $v === 0) {
			$this->ilosc_pobran = $v;
			$this->modifiedColumns[] = RepozytoriumPeer::ILOSC_POBRAN;
		}

		return $this;
	} 
	
	public function setIloscDowiazan($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->ilosc_dowiazan !== $v || $v === 0) {
			$this->ilosc_dowiazan = $v;
			$this->modifiedColumns[] = RepozytoriumPeer::ILOSC_DOWIAZAN;
		}

		return $this;
	} 
	
	public function setCreatedAt($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->created_at !== null || $dt !== null ) {
			
			$currNorm = ($this->created_at !== null && $tmpDt = new DateTime($this->created_at)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->created_at = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = RepozytoriumPeer::CREATED_AT;
			}
		} 
		return $this;
	} 
	
	public function setUpdatedAt($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->updated_at !== null || $dt !== null ) {
			
			$currNorm = ($this->updated_at !== null && $tmpDt = new DateTime($this->updated_at)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->updated_at = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = RepozytoriumPeer::UPDATED_AT;
			}
		} 
		return $this;
	} 
	
	public function hasOnlyDefaultValues()
	{
						if (array_diff($this->modifiedColumns, array(RepozytoriumPeer::ILOSC_POBRAN,RepozytoriumPeer::ILOSC_DOWIAZAN))) {
				return false;
			}

			if ($this->ilosc_pobran !== 0) {
				return false;
			}

			if ($this->ilosc_dowiazan !== 0) {
				return false;
			}

				return true;
	} 
	
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->portal_id = ($row[$startcol + 1] !== null) ? (int) $row[$startcol + 1] : null;
			$this->sciezka = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
			$this->nazwa_pliku = ($row[$startcol + 3] !== null) ? (string) $row[$startcol + 3] : null;
			$this->nazwa_org = ($row[$startcol + 4] !== null) ? (string) $row[$startcol + 4] : null;
			$this->rozmiar_pliku = ($row[$startcol + 5] !== null) ? (int) $row[$startcol + 5] : null;
			$this->format_pliku = ($row[$startcol + 6] !== null) ? (string) $row[$startcol + 6] : null;
			$this->mime_type = ($row[$startcol + 7] !== null) ? (string) $row[$startcol + 7] : null;
			$this->tresc_pliku = ($row[$startcol + 8] !== null) ? (string) $row[$startcol + 8] : null;
			$this->nazwa = ($row[$startcol + 9] !== null) ? (string) $row[$startcol + 9] : null;
			$this->opis = ($row[$startcol + 10] !== null) ? (string) $row[$startcol + 10] : null;
			$this->ilosc_pobran = ($row[$startcol + 11] !== null) ? (int) $row[$startcol + 11] : null;
			$this->ilosc_dowiazan = ($row[$startcol + 12] !== null) ? (int) $row[$startcol + 12] : null;
			$this->created_at = ($row[$startcol + 13] !== null) ? (string) $row[$startcol + 13] : null;
			$this->updated_at = ($row[$startcol + 14] !== null) ? (string) $row[$startcol + 14] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

						return $startcol + 15; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Repozytorium object", $e);
		}
	}

	
	public function ensureConsistency()
	{

		if ($this->aPortal !== null && $this->portal_id !== $this->aPortal->getId()) {
			$this->aPortal = null;
		}
	} 
	
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(RepozytoriumPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

				
		$stmt = RepozytoriumPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); 
		if ($deep) {  
			$this->aPortal = null;
			$this->collRepozytoriumKategoriaMaps = null;
			$this->lastRepozytoriumKategoriaMapCriteria = null;

			$this->collRepozytoriumModulMaps = null;
			$this->lastRepozytoriumModulMapCriteria = null;

		} 	}

	
	public function delete(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(RepozytoriumPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			RepozytoriumPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	public function save(PropelPDO $con = null)
	{
    if ($this->isNew() && !$this->isColumnModified(RepozytoriumPeer::CREATED_AT))
    {
      $this->setCreatedAt(time());
    }

    if ($this->isModified() && !$this->isColumnModified(RepozytoriumPeer::UPDATED_AT))
    {
      $this->setUpdatedAt(time());
    }

		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(RepozytoriumPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
			RepozytoriumPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

												
			if ($this->aPortal !== null) {
				if ($this->aPortal->isModified() || $this->aPortal->isNew()) {
					$affectedRows += $this->aPortal->save($con);
				}
				$this->setPortal($this->aPortal);
			}

			if ($this->isNew() ) {
				$this->modifiedColumns[] = RepozytoriumPeer::ID;
			}

						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = RepozytoriumPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += RepozytoriumPeer::doUpdate($this, $con);
				}

				$this->resetModified(); 			}

			if ($this->collRepozytoriumKategoriaMaps !== null) {
				foreach ($this->collRepozytoriumKategoriaMaps as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collRepozytoriumModulMaps !== null) {
				foreach ($this->collRepozytoriumModulMaps as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aPortal !== null) {
				if (!$this->aPortal->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aPortal->getValidationFailures());
				}
			}


			if (($retval = RepozytoriumPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collRepozytoriumKategoriaMaps !== null) {
					foreach ($this->collRepozytoriumKategoriaMaps as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collRepozytoriumModulMaps !== null) {
					foreach ($this->collRepozytoriumModulMaps as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = RepozytoriumPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getPortalId();
				break;
			case 2:
				return $this->getSciezka();
				break;
			case 3:
				return $this->getNazwaPliku();
				break;
			case 4:
				return $this->getNazwaOrg();
				break;
			case 5:
				return $this->getRozmiarPliku();
				break;
			case 6:
				return $this->getFormatPliku();
				break;
			case 7:
				return $this->getMimeType();
				break;
			case 8:
				return $this->getTrescPliku();
				break;
			case 9:
				return $this->getNazwa();
				break;
			case 10:
				return $this->getOpis();
				break;
			case 11:
				return $this->getIloscPobran();
				break;
			case 12:
				return $this->getIloscDowiazan();
				break;
			case 13:
				return $this->getCreatedAt();
				break;
			case 14:
				return $this->getUpdatedAt();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = RepozytoriumPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getPortalId(),
			$keys[2] => $this->getSciezka(),
			$keys[3] => $this->getNazwaPliku(),
			$keys[4] => $this->getNazwaOrg(),
			$keys[5] => $this->getRozmiarPliku(),
			$keys[6] => $this->getFormatPliku(),
			$keys[7] => $this->getMimeType(),
			$keys[8] => $this->getTrescPliku(),
			$keys[9] => $this->getNazwa(),
			$keys[10] => $this->getOpis(),
			$keys[11] => $this->getIloscPobran(),
			$keys[12] => $this->getIloscDowiazan(),
			$keys[13] => $this->getCreatedAt(),
			$keys[14] => $this->getUpdatedAt(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = RepozytoriumPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setPortalId($value);
				break;
			case 2:
				$this->setSciezka($value);
				break;
			case 3:
				$this->setNazwaPliku($value);
				break;
			case 4:
				$this->setNazwaOrg($value);
				break;
			case 5:
				$this->setRozmiarPliku($value);
				break;
			case 6:
				$this->setFormatPliku($value);
				break;
			case 7:
				$this->setMimeType($value);
				break;
			case 8:
				$this->setTrescPliku($value);
				break;
			case 9:
				$this->setNazwa($value);
				break;
			case 10:
				$this->setOpis($value);
				break;
			case 11:
				$this->setIloscPobran($value);
				break;
			case 12:
				$this->setIloscDowiazan($value);
				break;
			case 13:
				$this->setCreatedAt($value);
				break;
			case 14:
				$this->setUpdatedAt($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = RepozytoriumPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setPortalId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setSciezka($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setNazwaPliku($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setNazwaOrg($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setRozmiarPliku($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setFormatPliku($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setMimeType($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setTrescPliku($arr[$keys[8]]);
		if (array_key_exists($keys[9], $arr)) $this->setNazwa($arr[$keys[9]]);
		if (array_key_exists($keys[10], $arr)) $this->setOpis($arr[$keys[10]]);
		if (array_key_exists($keys[11], $arr)) $this->setIloscPobran($arr[$keys[11]]);
		if (array_key_exists($keys[12], $arr)) $this->setIloscDowiazan($arr[$keys[12]]);
		if (array_key_exists($keys[13], $arr)) $this->setCreatedAt($arr[$keys[13]]);
		if (array_key_exists($keys[14], $arr)) $this->setUpdatedAt($arr[$keys[14]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(RepozytoriumPeer::DATABASE_NAME);

		if ($this->isColumnModified(RepozytoriumPeer::ID)) $criteria->add(RepozytoriumPeer::ID, $this->id);
		if ($this->isColumnModified(RepozytoriumPeer::PORTAL_ID)) $criteria->add(RepozytoriumPeer::PORTAL_ID, $this->portal_id);
		if ($this->isColumnModified(RepozytoriumPeer::SCIEZKA)) $criteria->add(RepozytoriumPeer::SCIEZKA, $this->sciezka);
		if ($this->isColumnModified(RepozytoriumPeer::NAZWA_PLIKU)) $criteria->add(RepozytoriumPeer::NAZWA_PLIKU, $this->nazwa_pliku);
		if ($this->isColumnModified(RepozytoriumPeer::NAZWA_ORG)) $criteria->add(RepozytoriumPeer::NAZWA_ORG, $this->nazwa_org);
		if ($this->isColumnModified(RepozytoriumPeer::ROZMIAR_PLIKU)) $criteria->add(RepozytoriumPeer::ROZMIAR_PLIKU, $this->rozmiar_pliku);
		if ($this->isColumnModified(RepozytoriumPeer::FORMAT_PLIKU)) $criteria->add(RepozytoriumPeer::FORMAT_PLIKU, $this->format_pliku);
		if ($this->isColumnModified(RepozytoriumPeer::MIME_TYPE)) $criteria->add(RepozytoriumPeer::MIME_TYPE, $this->mime_type);
		if ($this->isColumnModified(RepozytoriumPeer::TRESC_PLIKU)) $criteria->add(RepozytoriumPeer::TRESC_PLIKU, $this->tresc_pliku);
		if ($this->isColumnModified(RepozytoriumPeer::NAZWA)) $criteria->add(RepozytoriumPeer::NAZWA, $this->nazwa);
		if ($this->isColumnModified(RepozytoriumPeer::OPIS)) $criteria->add(RepozytoriumPeer::OPIS, $this->opis);
		if ($this->isColumnModified(RepozytoriumPeer::ILOSC_POBRAN)) $criteria->add(RepozytoriumPeer::ILOSC_POBRAN, $this->ilosc_pobran);
		if ($this->isColumnModified(RepozytoriumPeer::ILOSC_DOWIAZAN)) $criteria->add(RepozytoriumPeer::ILOSC_DOWIAZAN, $this->ilosc_dowiazan);
		if ($this->isColumnModified(RepozytoriumPeer::CREATED_AT)) $criteria->add(RepozytoriumPeer::CREATED_AT, $this->created_at);
		if ($this->isColumnModified(RepozytoriumPeer::UPDATED_AT)) $criteria->add(RepozytoriumPeer::UPDATED_AT, $this->updated_at);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(RepozytoriumPeer::DATABASE_NAME);

		$criteria->add(RepozytoriumPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setPortalId($this->portal_id);

		$copyObj->setSciezka($this->sciezka);

		$copyObj->setNazwaPliku($this->nazwa_pliku);

		$copyObj->setNazwaOrg($this->nazwa_org);

		$copyObj->setRozmiarPliku($this->rozmiar_pliku);

		$copyObj->setFormatPliku($this->format_pliku);

		$copyObj->setMimeType($this->mime_type);

		$copyObj->setTrescPliku($this->tresc_pliku);

		$copyObj->setNazwa($this->nazwa);

		$copyObj->setOpis($this->opis);

		$copyObj->setIloscPobran($this->ilosc_pobran);

		$copyObj->setIloscDowiazan($this->ilosc_dowiazan);

		$copyObj->setCreatedAt($this->created_at);

		$copyObj->setUpdatedAt($this->updated_at);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach ($this->getRepozytoriumKategoriaMaps() as $relObj) {
				if ($relObj !== $this) {  					$copyObj->addRepozytoriumKategoriaMap($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getRepozytoriumModulMaps() as $relObj) {
				if ($relObj !== $this) {  					$copyObj->addRepozytoriumModulMap($relObj->copy($deepCopy));
				}
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new RepozytoriumPeer();
		}
		return self::$peer;
	}

	
	public function setPortal(Portal $v = null)
	{
		if ($v === null) {
			$this->setPortalId(NULL);
		} else {
			$this->setPortalId($v->getId());
		}

		$this->aPortal = $v;

						if ($v !== null) {
			$v->addRepozytorium($this);
		}

		return $this;
	}


	
	public function getPortal(PropelPDO $con = null)
	{
		if ($this->aPortal === null && ($this->portal_id !== null)) {
			$c = new Criteria(PortalPeer::DATABASE_NAME);
			$c->add(PortalPeer::ID, $this->portal_id);
			$this->aPortal = PortalPeer::doSelectOne($c, $con);
			
		}
		return $this->aPortal;
	}

	
	public function clearRepozytoriumKategoriaMaps()
	{
		$this->collRepozytoriumKategoriaMaps = null; 	}

	
	public function initRepozytoriumKategoriaMaps()
	{
		$this->collRepozytoriumKategoriaMaps = array();
	}

	
	public function getRepozytoriumKategoriaMaps($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(RepozytoriumPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collRepozytoriumKategoriaMaps === null) {
			if ($this->isNew()) {
			   $this->collRepozytoriumKategoriaMaps = array();
			} else {

				$criteria->add(RepozytoriumKategoriaMapPeer::REPOZYTORIUM_ID, $this->id);

				RepozytoriumKategoriaMapPeer::addSelectColumns($criteria);
				$this->collRepozytoriumKategoriaMaps = RepozytoriumKategoriaMapPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(RepozytoriumKategoriaMapPeer::REPOZYTORIUM_ID, $this->id);

				RepozytoriumKategoriaMapPeer::addSelectColumns($criteria);
				if (!isset($this->lastRepozytoriumKategoriaMapCriteria) || !$this->lastRepozytoriumKategoriaMapCriteria->equals($criteria)) {
					$this->collRepozytoriumKategoriaMaps = RepozytoriumKategoriaMapPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastRepozytoriumKategoriaMapCriteria = $criteria;
		return $this->collRepozytoriumKategoriaMaps;
	}

	
	public function countRepozytoriumKategoriaMaps(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(RepozytoriumPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collRepozytoriumKategoriaMaps === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(RepozytoriumKategoriaMapPeer::REPOZYTORIUM_ID, $this->id);

				$count = RepozytoriumKategoriaMapPeer::doCount($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(RepozytoriumKategoriaMapPeer::REPOZYTORIUM_ID, $this->id);

				if (!isset($this->lastRepozytoriumKategoriaMapCriteria) || !$this->lastRepozytoriumKategoriaMapCriteria->equals($criteria)) {
					$count = RepozytoriumKategoriaMapPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collRepozytoriumKategoriaMaps);
				}
			} else {
				$count = count($this->collRepozytoriumKategoriaMaps);
			}
		}
		return $count;
	}

	
	public function addRepozytoriumKategoriaMap(RepozytoriumKategoriaMap $l)
	{
		if ($this->collRepozytoriumKategoriaMaps === null) {
			$this->initRepozytoriumKategoriaMaps();
		}
		if (!in_array($l, $this->collRepozytoriumKategoriaMaps, true)) { 			array_push($this->collRepozytoriumKategoriaMaps, $l);
			$l->setRepozytorium($this);
		}
	}


	
	public function getRepozytoriumKategoriaMapsJoinRepozytoriumKategoria($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(RepozytoriumPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collRepozytoriumKategoriaMaps === null) {
			if ($this->isNew()) {
				$this->collRepozytoriumKategoriaMaps = array();
			} else {

				$criteria->add(RepozytoriumKategoriaMapPeer::REPOZYTORIUM_ID, $this->id);

				$this->collRepozytoriumKategoriaMaps = RepozytoriumKategoriaMapPeer::doSelectJoinRepozytoriumKategoria($criteria, $con, $join_behavior);
			}
		} else {
									
			$criteria->add(RepozytoriumKategoriaMapPeer::REPOZYTORIUM_ID, $this->id);

			if (!isset($this->lastRepozytoriumKategoriaMapCriteria) || !$this->lastRepozytoriumKategoriaMapCriteria->equals($criteria)) {
				$this->collRepozytoriumKategoriaMaps = RepozytoriumKategoriaMapPeer::doSelectJoinRepozytoriumKategoria($criteria, $con, $join_behavior);
			}
		}
		$this->lastRepozytoriumKategoriaMapCriteria = $criteria;

		return $this->collRepozytoriumKategoriaMaps;
	}

	
	public function clearRepozytoriumModulMaps()
	{
		$this->collRepozytoriumModulMaps = null; 	}

	
	public function initRepozytoriumModulMaps()
	{
		$this->collRepozytoriumModulMaps = array();
	}

	
	public function getRepozytoriumModulMaps($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(RepozytoriumPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collRepozytoriumModulMaps === null) {
			if ($this->isNew()) {
			   $this->collRepozytoriumModulMaps = array();
			} else {

				$criteria->add(RepozytoriumModulMapPeer::REPOZYTORIUM_ID, $this->id);

				RepozytoriumModulMapPeer::addSelectColumns($criteria);
				$this->collRepozytoriumModulMaps = RepozytoriumModulMapPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(RepozytoriumModulMapPeer::REPOZYTORIUM_ID, $this->id);

				RepozytoriumModulMapPeer::addSelectColumns($criteria);
				if (!isset($this->lastRepozytoriumModulMapCriteria) || !$this->lastRepozytoriumModulMapCriteria->equals($criteria)) {
					$this->collRepozytoriumModulMaps = RepozytoriumModulMapPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastRepozytoriumModulMapCriteria = $criteria;
		return $this->collRepozytoriumModulMaps;
	}

	
	public function countRepozytoriumModulMaps(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(RepozytoriumPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collRepozytoriumModulMaps === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(RepozytoriumModulMapPeer::REPOZYTORIUM_ID, $this->id);

				$count = RepozytoriumModulMapPeer::doCount($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(RepozytoriumModulMapPeer::REPOZYTORIUM_ID, $this->id);

				if (!isset($this->lastRepozytoriumModulMapCriteria) || !$this->lastRepozytoriumModulMapCriteria->equals($criteria)) {
					$count = RepozytoriumModulMapPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collRepozytoriumModulMaps);
				}
			} else {
				$count = count($this->collRepozytoriumModulMaps);
			}
		}
		return $count;
	}

	
	public function addRepozytoriumModulMap(RepozytoriumModulMap $l)
	{
		if ($this->collRepozytoriumModulMaps === null) {
			$this->initRepozytoriumModulMaps();
		}
		if (!in_array($l, $this->collRepozytoriumModulMaps, true)) { 			array_push($this->collRepozytoriumModulMaps, $l);
			$l->setRepozytorium($this);
		}
	}


	
	public function getRepozytoriumModulMapsJoinModul($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(RepozytoriumPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collRepozytoriumModulMaps === null) {
			if ($this->isNew()) {
				$this->collRepozytoriumModulMaps = array();
			} else {

				$criteria->add(RepozytoriumModulMapPeer::REPOZYTORIUM_ID, $this->id);

				$this->collRepozytoriumModulMaps = RepozytoriumModulMapPeer::doSelectJoinModul($criteria, $con, $join_behavior);
			}
		} else {
									
			$criteria->add(RepozytoriumModulMapPeer::REPOZYTORIUM_ID, $this->id);

			if (!isset($this->lastRepozytoriumModulMapCriteria) || !$this->lastRepozytoriumModulMapCriteria->equals($criteria)) {
				$this->collRepozytoriumModulMaps = RepozytoriumModulMapPeer::doSelectJoinModul($criteria, $con, $join_behavior);
			}
		}
		$this->lastRepozytoriumModulMapCriteria = $criteria;

		return $this->collRepozytoriumModulMaps;
	}

	
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
			if ($this->collRepozytoriumKategoriaMaps) {
				foreach ((array) $this->collRepozytoriumKategoriaMaps as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collRepozytoriumModulMaps) {
				foreach ((array) $this->collRepozytoriumModulMaps as $o) {
					$o->clearAllReferences($deep);
				}
			}
		} 
		$this->collRepozytoriumKategoriaMaps = null;
		$this->collRepozytoriumModulMaps = null;
			$this->aPortal = null;
	}

} 