<?php


abstract class BaseRepozytoriumKategoria extends BaseObject  implements Persistent {


  const PEER = 'RepozytoriumKategoriaPeer';

	
	protected static $peer;

	
	protected $id;

	
	protected $portal_id;

	
	protected $nazwa;

	
	protected $opis;

	
	protected $widoczna;

	
	protected $kolejnosc;

	
	protected $created_at;

	
	protected $updated_at;

	
	protected $aPortal;

	
	protected $collRepozytoriumKategoriaMaps;

	
	private $lastRepozytoriumKategoriaMapCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	
	public function applyDefaultValues()
	{
		$this->widoczna = 1;
	}

	
	public function getId()
	{
		return $this->id;
	}

	
	public function getPortalId()
	{
		return $this->portal_id;
	}

	
	public function getNazwa()
	{
		return $this->nazwa;
	}

	
	public function getOpis()
	{
		return $this->opis;
	}

	
	public function getWidoczna()
	{
		return $this->widoczna;
	}

	
	public function getKolejnosc()
	{
		return $this->kolejnosc;
	}

	
	public function getCreatedAt($format = 'Y-m-d H:i:s')
	{
		if ($this->created_at === null) {
			return null;
		}


		if ($this->created_at === '0000-00-00 00:00:00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->created_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->created_at, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function getUpdatedAt($format = 'Y-m-d H:i:s')
	{
		if ($this->updated_at === null) {
			return null;
		}


		if ($this->updated_at === '0000-00-00 00:00:00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->updated_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->updated_at, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function setId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = RepozytoriumKategoriaPeer::ID;
		}

		return $this;
	} 
	
	public function setPortalId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->portal_id !== $v) {
			$this->portal_id = $v;
			$this->modifiedColumns[] = RepozytoriumKategoriaPeer::PORTAL_ID;
		}

		if ($this->aPortal !== null && $this->aPortal->getId() !== $v) {
			$this->aPortal = null;
		}

		return $this;
	} 
	
	public function setNazwa($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->nazwa !== $v) {
			$this->nazwa = $v;
			$this->modifiedColumns[] = RepozytoriumKategoriaPeer::NAZWA;
		}

		return $this;
	} 
	
	public function setOpis($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->opis !== $v) {
			$this->opis = $v;
			$this->modifiedColumns[] = RepozytoriumKategoriaPeer::OPIS;
		}

		return $this;
	} 
	
	public function setWidoczna($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->widoczna !== $v || $v === 1) {
			$this->widoczna = $v;
			$this->modifiedColumns[] = RepozytoriumKategoriaPeer::WIDOCZNA;
		}

		return $this;
	} 
	
	public function setKolejnosc($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->kolejnosc !== $v) {
			$this->kolejnosc = $v;
			$this->modifiedColumns[] = RepozytoriumKategoriaPeer::KOLEJNOSC;
		}

		return $this;
	} 
	
	public function setCreatedAt($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->created_at !== null || $dt !== null ) {
			
			$currNorm = ($this->created_at !== null && $tmpDt = new DateTime($this->created_at)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->created_at = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = RepozytoriumKategoriaPeer::CREATED_AT;
			}
		} 
		return $this;
	} 
	
	public function setUpdatedAt($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->updated_at !== null || $dt !== null ) {
			
			$currNorm = ($this->updated_at !== null && $tmpDt = new DateTime($this->updated_at)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->updated_at = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = RepozytoriumKategoriaPeer::UPDATED_AT;
			}
		} 
		return $this;
	} 
	
	public function hasOnlyDefaultValues()
	{
						if (array_diff($this->modifiedColumns, array(RepozytoriumKategoriaPeer::WIDOCZNA))) {
				return false;
			}

			if ($this->widoczna !== 1) {
				return false;
			}

				return true;
	} 
	
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->portal_id = ($row[$startcol + 1] !== null) ? (int) $row[$startcol + 1] : null;
			$this->nazwa = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
			$this->opis = ($row[$startcol + 3] !== null) ? (string) $row[$startcol + 3] : null;
			$this->widoczna = ($row[$startcol + 4] !== null) ? (int) $row[$startcol + 4] : null;
			$this->kolejnosc = ($row[$startcol + 5] !== null) ? (int) $row[$startcol + 5] : null;
			$this->created_at = ($row[$startcol + 6] !== null) ? (string) $row[$startcol + 6] : null;
			$this->updated_at = ($row[$startcol + 7] !== null) ? (string) $row[$startcol + 7] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

						return $startcol + 8; 
		} catch (Exception $e) {
			throw new PropelException("Error populating RepozytoriumKategoria object", $e);
		}
	}

	
	public function ensureConsistency()
	{

		if ($this->aPortal !== null && $this->portal_id !== $this->aPortal->getId()) {
			$this->aPortal = null;
		}
	} 
	
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(RepozytoriumKategoriaPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

				
		$stmt = RepozytoriumKategoriaPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); 
		if ($deep) {  
			$this->aPortal = null;
			$this->collRepozytoriumKategoriaMaps = null;
			$this->lastRepozytoriumKategoriaMapCriteria = null;

		} 	}

	
	public function delete(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(RepozytoriumKategoriaPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			RepozytoriumKategoriaPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	public function save(PropelPDO $con = null)
	{
    if ($this->isNew() && !$this->isColumnModified(RepozytoriumKategoriaPeer::CREATED_AT))
    {
      $this->setCreatedAt(time());
    }

    if ($this->isModified() && !$this->isColumnModified(RepozytoriumKategoriaPeer::UPDATED_AT))
    {
      $this->setUpdatedAt(time());
    }

		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(RepozytoriumKategoriaPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
			RepozytoriumKategoriaPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

												
			if ($this->aPortal !== null) {
				if ($this->aPortal->isModified() || $this->aPortal->isNew()) {
					$affectedRows += $this->aPortal->save($con);
				}
				$this->setPortal($this->aPortal);
			}

			if ($this->isNew() ) {
				$this->modifiedColumns[] = RepozytoriumKategoriaPeer::ID;
			}

						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = RepozytoriumKategoriaPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += RepozytoriumKategoriaPeer::doUpdate($this, $con);
				}

				$this->resetModified(); 			}

			if ($this->collRepozytoriumKategoriaMaps !== null) {
				foreach ($this->collRepozytoriumKategoriaMaps as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aPortal !== null) {
				if (!$this->aPortal->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aPortal->getValidationFailures());
				}
			}


			if (($retval = RepozytoriumKategoriaPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collRepozytoriumKategoriaMaps !== null) {
					foreach ($this->collRepozytoriumKategoriaMaps as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = RepozytoriumKategoriaPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getPortalId();
				break;
			case 2:
				return $this->getNazwa();
				break;
			case 3:
				return $this->getOpis();
				break;
			case 4:
				return $this->getWidoczna();
				break;
			case 5:
				return $this->getKolejnosc();
				break;
			case 6:
				return $this->getCreatedAt();
				break;
			case 7:
				return $this->getUpdatedAt();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = RepozytoriumKategoriaPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getPortalId(),
			$keys[2] => $this->getNazwa(),
			$keys[3] => $this->getOpis(),
			$keys[4] => $this->getWidoczna(),
			$keys[5] => $this->getKolejnosc(),
			$keys[6] => $this->getCreatedAt(),
			$keys[7] => $this->getUpdatedAt(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = RepozytoriumKategoriaPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setPortalId($value);
				break;
			case 2:
				$this->setNazwa($value);
				break;
			case 3:
				$this->setOpis($value);
				break;
			case 4:
				$this->setWidoczna($value);
				break;
			case 5:
				$this->setKolejnosc($value);
				break;
			case 6:
				$this->setCreatedAt($value);
				break;
			case 7:
				$this->setUpdatedAt($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = RepozytoriumKategoriaPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setPortalId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setNazwa($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setOpis($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setWidoczna($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setKolejnosc($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setCreatedAt($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setUpdatedAt($arr[$keys[7]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(RepozytoriumKategoriaPeer::DATABASE_NAME);

		if ($this->isColumnModified(RepozytoriumKategoriaPeer::ID)) $criteria->add(RepozytoriumKategoriaPeer::ID, $this->id);
		if ($this->isColumnModified(RepozytoriumKategoriaPeer::PORTAL_ID)) $criteria->add(RepozytoriumKategoriaPeer::PORTAL_ID, $this->portal_id);
		if ($this->isColumnModified(RepozytoriumKategoriaPeer::NAZWA)) $criteria->add(RepozytoriumKategoriaPeer::NAZWA, $this->nazwa);
		if ($this->isColumnModified(RepozytoriumKategoriaPeer::OPIS)) $criteria->add(RepozytoriumKategoriaPeer::OPIS, $this->opis);
		if ($this->isColumnModified(RepozytoriumKategoriaPeer::WIDOCZNA)) $criteria->add(RepozytoriumKategoriaPeer::WIDOCZNA, $this->widoczna);
		if ($this->isColumnModified(RepozytoriumKategoriaPeer::KOLEJNOSC)) $criteria->add(RepozytoriumKategoriaPeer::KOLEJNOSC, $this->kolejnosc);
		if ($this->isColumnModified(RepozytoriumKategoriaPeer::CREATED_AT)) $criteria->add(RepozytoriumKategoriaPeer::CREATED_AT, $this->created_at);
		if ($this->isColumnModified(RepozytoriumKategoriaPeer::UPDATED_AT)) $criteria->add(RepozytoriumKategoriaPeer::UPDATED_AT, $this->updated_at);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(RepozytoriumKategoriaPeer::DATABASE_NAME);

		$criteria->add(RepozytoriumKategoriaPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setPortalId($this->portal_id);

		$copyObj->setNazwa($this->nazwa);

		$copyObj->setOpis($this->opis);

		$copyObj->setWidoczna($this->widoczna);

		$copyObj->setKolejnosc($this->kolejnosc);

		$copyObj->setCreatedAt($this->created_at);

		$copyObj->setUpdatedAt($this->updated_at);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach ($this->getRepozytoriumKategoriaMaps() as $relObj) {
				if ($relObj !== $this) {  					$copyObj->addRepozytoriumKategoriaMap($relObj->copy($deepCopy));
				}
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new RepozytoriumKategoriaPeer();
		}
		return self::$peer;
	}

	
	public function setPortal(Portal $v = null)
	{
		if ($v === null) {
			$this->setPortalId(NULL);
		} else {
			$this->setPortalId($v->getId());
		}

		$this->aPortal = $v;

						if ($v !== null) {
			$v->addRepozytoriumKategoria($this);
		}

		return $this;
	}


	
	public function getPortal(PropelPDO $con = null)
	{
		if ($this->aPortal === null && ($this->portal_id !== null)) {
			$c = new Criteria(PortalPeer::DATABASE_NAME);
			$c->add(PortalPeer::ID, $this->portal_id);
			$this->aPortal = PortalPeer::doSelectOne($c, $con);
			
		}
		return $this->aPortal;
	}

	
	public function clearRepozytoriumKategoriaMaps()
	{
		$this->collRepozytoriumKategoriaMaps = null; 	}

	
	public function initRepozytoriumKategoriaMaps()
	{
		$this->collRepozytoriumKategoriaMaps = array();
	}

	
	public function getRepozytoriumKategoriaMaps($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(RepozytoriumKategoriaPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collRepozytoriumKategoriaMaps === null) {
			if ($this->isNew()) {
			   $this->collRepozytoriumKategoriaMaps = array();
			} else {

				$criteria->add(RepozytoriumKategoriaMapPeer::REPOZYTORIUM_KATEGORIA_ID, $this->id);

				RepozytoriumKategoriaMapPeer::addSelectColumns($criteria);
				$this->collRepozytoriumKategoriaMaps = RepozytoriumKategoriaMapPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(RepozytoriumKategoriaMapPeer::REPOZYTORIUM_KATEGORIA_ID, $this->id);

				RepozytoriumKategoriaMapPeer::addSelectColumns($criteria);
				if (!isset($this->lastRepozytoriumKategoriaMapCriteria) || !$this->lastRepozytoriumKategoriaMapCriteria->equals($criteria)) {
					$this->collRepozytoriumKategoriaMaps = RepozytoriumKategoriaMapPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastRepozytoriumKategoriaMapCriteria = $criteria;
		return $this->collRepozytoriumKategoriaMaps;
	}

	
	public function countRepozytoriumKategoriaMaps(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(RepozytoriumKategoriaPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collRepozytoriumKategoriaMaps === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(RepozytoriumKategoriaMapPeer::REPOZYTORIUM_KATEGORIA_ID, $this->id);

				$count = RepozytoriumKategoriaMapPeer::doCount($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(RepozytoriumKategoriaMapPeer::REPOZYTORIUM_KATEGORIA_ID, $this->id);

				if (!isset($this->lastRepozytoriumKategoriaMapCriteria) || !$this->lastRepozytoriumKategoriaMapCriteria->equals($criteria)) {
					$count = RepozytoriumKategoriaMapPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collRepozytoriumKategoriaMaps);
				}
			} else {
				$count = count($this->collRepozytoriumKategoriaMaps);
			}
		}
		return $count;
	}

	
	public function addRepozytoriumKategoriaMap(RepozytoriumKategoriaMap $l)
	{
		if ($this->collRepozytoriumKategoriaMaps === null) {
			$this->initRepozytoriumKategoriaMaps();
		}
		if (!in_array($l, $this->collRepozytoriumKategoriaMaps, true)) { 			array_push($this->collRepozytoriumKategoriaMaps, $l);
			$l->setRepozytoriumKategoria($this);
		}
	}


	
	public function getRepozytoriumKategoriaMapsJoinRepozytorium($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(RepozytoriumKategoriaPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collRepozytoriumKategoriaMaps === null) {
			if ($this->isNew()) {
				$this->collRepozytoriumKategoriaMaps = array();
			} else {

				$criteria->add(RepozytoriumKategoriaMapPeer::REPOZYTORIUM_KATEGORIA_ID, $this->id);

				$this->collRepozytoriumKategoriaMaps = RepozytoriumKategoriaMapPeer::doSelectJoinRepozytorium($criteria, $con, $join_behavior);
			}
		} else {
									
			$criteria->add(RepozytoriumKategoriaMapPeer::REPOZYTORIUM_KATEGORIA_ID, $this->id);

			if (!isset($this->lastRepozytoriumKategoriaMapCriteria) || !$this->lastRepozytoriumKategoriaMapCriteria->equals($criteria)) {
				$this->collRepozytoriumKategoriaMaps = RepozytoriumKategoriaMapPeer::doSelectJoinRepozytorium($criteria, $con, $join_behavior);
			}
		}
		$this->lastRepozytoriumKategoriaMapCriteria = $criteria;

		return $this->collRepozytoriumKategoriaMaps;
	}

	
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
			if ($this->collRepozytoriumKategoriaMaps) {
				foreach ((array) $this->collRepozytoriumKategoriaMaps as $o) {
					$o->clearAllReferences($deep);
				}
			}
		} 
		$this->collRepozytoriumKategoriaMaps = null;
			$this->aPortal = null;
	}

} 