<?php


abstract class BaseRepozytoriumKategoriaMap extends BaseObject  implements Persistent {


  const PEER = 'RepozytoriumKategoriaMapPeer';

	
	protected static $peer;

	
	protected $repozytorium_id;

	
	protected $repozytorium_kategoria_id;

	
	protected $aRepozytorium;

	
	protected $aRepozytoriumKategoria;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	
	public function applyDefaultValues()
	{
	}

	
	public function getRepozytoriumId()
	{
		return $this->repozytorium_id;
	}

	
	public function getRepozytoriumKategoriaId()
	{
		return $this->repozytorium_kategoria_id;
	}

	
	public function setRepozytoriumId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->repozytorium_id !== $v) {
			$this->repozytorium_id = $v;
			$this->modifiedColumns[] = RepozytoriumKategoriaMapPeer::REPOZYTORIUM_ID;
		}

		if ($this->aRepozytorium !== null && $this->aRepozytorium->getId() !== $v) {
			$this->aRepozytorium = null;
		}

		return $this;
	} 
	
	public function setRepozytoriumKategoriaId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->repozytorium_kategoria_id !== $v) {
			$this->repozytorium_kategoria_id = $v;
			$this->modifiedColumns[] = RepozytoriumKategoriaMapPeer::REPOZYTORIUM_KATEGORIA_ID;
		}

		if ($this->aRepozytoriumKategoria !== null && $this->aRepozytoriumKategoria->getId() !== $v) {
			$this->aRepozytoriumKategoria = null;
		}

		return $this;
	} 
	
	public function hasOnlyDefaultValues()
	{
						if (array_diff($this->modifiedColumns, array())) {
				return false;
			}

				return true;
	} 
	
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->repozytorium_id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->repozytorium_kategoria_id = ($row[$startcol + 1] !== null) ? (int) $row[$startcol + 1] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

						return $startcol + 2; 
		} catch (Exception $e) {
			throw new PropelException("Error populating RepozytoriumKategoriaMap object", $e);
		}
	}

	
	public function ensureConsistency()
	{

		if ($this->aRepozytorium !== null && $this->repozytorium_id !== $this->aRepozytorium->getId()) {
			$this->aRepozytorium = null;
		}
		if ($this->aRepozytoriumKategoria !== null && $this->repozytorium_kategoria_id !== $this->aRepozytoriumKategoria->getId()) {
			$this->aRepozytoriumKategoria = null;
		}
	} 
	
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(RepozytoriumKategoriaMapPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

				
		$stmt = RepozytoriumKategoriaMapPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); 
		if ($deep) {  
			$this->aRepozytorium = null;
			$this->aRepozytoriumKategoria = null;
		} 	}

	
	public function delete(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(RepozytoriumKategoriaMapPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			RepozytoriumKategoriaMapPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	public function save(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(RepozytoriumKategoriaMapPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
			RepozytoriumKategoriaMapPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

												
			if ($this->aRepozytorium !== null) {
				if ($this->aRepozytorium->isModified() || $this->aRepozytorium->isNew()) {
					$affectedRows += $this->aRepozytorium->save($con);
				}
				$this->setRepozytorium($this->aRepozytorium);
			}

			if ($this->aRepozytoriumKategoria !== null) {
				if ($this->aRepozytoriumKategoria->isModified() || $this->aRepozytoriumKategoria->isNew()) {
					$affectedRows += $this->aRepozytoriumKategoria->save($con);
				}
				$this->setRepozytoriumKategoria($this->aRepozytoriumKategoria);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = RepozytoriumKategoriaMapPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setNew(false);
				} else {
					$affectedRows += RepozytoriumKategoriaMapPeer::doUpdate($this, $con);
				}

				$this->resetModified(); 			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aRepozytorium !== null) {
				if (!$this->aRepozytorium->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aRepozytorium->getValidationFailures());
				}
			}

			if ($this->aRepozytoriumKategoria !== null) {
				if (!$this->aRepozytoriumKategoria->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aRepozytoriumKategoria->getValidationFailures());
				}
			}


			if (($retval = RepozytoriumKategoriaMapPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = RepozytoriumKategoriaMapPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getRepozytoriumId();
				break;
			case 1:
				return $this->getRepozytoriumKategoriaId();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = RepozytoriumKategoriaMapPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getRepozytoriumId(),
			$keys[1] => $this->getRepozytoriumKategoriaId(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = RepozytoriumKategoriaMapPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setRepozytoriumId($value);
				break;
			case 1:
				$this->setRepozytoriumKategoriaId($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = RepozytoriumKategoriaMapPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setRepozytoriumId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setRepozytoriumKategoriaId($arr[$keys[1]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(RepozytoriumKategoriaMapPeer::DATABASE_NAME);

		if ($this->isColumnModified(RepozytoriumKategoriaMapPeer::REPOZYTORIUM_ID)) $criteria->add(RepozytoriumKategoriaMapPeer::REPOZYTORIUM_ID, $this->repozytorium_id);
		if ($this->isColumnModified(RepozytoriumKategoriaMapPeer::REPOZYTORIUM_KATEGORIA_ID)) $criteria->add(RepozytoriumKategoriaMapPeer::REPOZYTORIUM_KATEGORIA_ID, $this->repozytorium_kategoria_id);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(RepozytoriumKategoriaMapPeer::DATABASE_NAME);

		$criteria->add(RepozytoriumKategoriaMapPeer::REPOZYTORIUM_ID, $this->repozytorium_id);
		$criteria->add(RepozytoriumKategoriaMapPeer::REPOZYTORIUM_KATEGORIA_ID, $this->repozytorium_kategoria_id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		$pks = array();

		$pks[0] = $this->getRepozytoriumId();

		$pks[1] = $this->getRepozytoriumKategoriaId();

		return $pks;
	}

	
	public function setPrimaryKey($keys)
	{

		$this->setRepozytoriumId($keys[0]);

		$this->setRepozytoriumKategoriaId($keys[1]);

	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setRepozytoriumId($this->repozytorium_id);

		$copyObj->setRepozytoriumKategoriaId($this->repozytorium_kategoria_id);


		$copyObj->setNew(true);

	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new RepozytoriumKategoriaMapPeer();
		}
		return self::$peer;
	}

	
	public function setRepozytorium(Repozytorium $v = null)
	{
		if ($v === null) {
			$this->setRepozytoriumId(NULL);
		} else {
			$this->setRepozytoriumId($v->getId());
		}

		$this->aRepozytorium = $v;

						if ($v !== null) {
			$v->addRepozytoriumKategoriaMap($this);
		}

		return $this;
	}


	
	public function getRepozytorium(PropelPDO $con = null)
	{
		if ($this->aRepozytorium === null && ($this->repozytorium_id !== null)) {
			$c = new Criteria(RepozytoriumPeer::DATABASE_NAME);
			$c->add(RepozytoriumPeer::ID, $this->repozytorium_id);
			$this->aRepozytorium = RepozytoriumPeer::doSelectOne($c, $con);
			
		}
		return $this->aRepozytorium;
	}

	
	public function setRepozytoriumKategoria(RepozytoriumKategoria $v = null)
	{
		if ($v === null) {
			$this->setRepozytoriumKategoriaId(NULL);
		} else {
			$this->setRepozytoriumKategoriaId($v->getId());
		}

		$this->aRepozytoriumKategoria = $v;

						if ($v !== null) {
			$v->addRepozytoriumKategoriaMap($this);
		}

		return $this;
	}


	
	public function getRepozytoriumKategoria(PropelPDO $con = null)
	{
		if ($this->aRepozytoriumKategoria === null && ($this->repozytorium_kategoria_id !== null)) {
			$c = new Criteria(RepozytoriumKategoriaPeer::DATABASE_NAME);
			$c->add(RepozytoriumKategoriaPeer::ID, $this->repozytorium_kategoria_id);
			$this->aRepozytoriumKategoria = RepozytoriumKategoriaPeer::doSelectOne($c, $con);
			
		}
		return $this->aRepozytoriumKategoria;
	}

	
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
		} 
			$this->aRepozytorium = null;
			$this->aRepozytoriumKategoria = null;
	}

} 