<?php


abstract class BaseRepozytoriumModulMap extends BaseObject  implements Persistent {


  const PEER = 'RepozytoriumModulMapPeer';

	
	protected static $peer;

	
	protected $repozytorium_id;

	
	protected $modul_id;

	
	protected $object_id;

	
	protected $aRepozytorium;

	
	protected $aModul;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	
	public function applyDefaultValues()
	{
	}

	
	public function getRepozytoriumId()
	{
		return $this->repozytorium_id;
	}

	
	public function getModulId()
	{
		return $this->modul_id;
	}

	
	public function getObjectId()
	{
		return $this->object_id;
	}

	
	public function setRepozytoriumId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->repozytorium_id !== $v) {
			$this->repozytorium_id = $v;
			$this->modifiedColumns[] = RepozytoriumModulMapPeer::REPOZYTORIUM_ID;
		}

		if ($this->aRepozytorium !== null && $this->aRepozytorium->getId() !== $v) {
			$this->aRepozytorium = null;
		}

		return $this;
	} 
	
	public function setModulId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->modul_id !== $v) {
			$this->modul_id = $v;
			$this->modifiedColumns[] = RepozytoriumModulMapPeer::MODUL_ID;
		}

		if ($this->aModul !== null && $this->aModul->getId() !== $v) {
			$this->aModul = null;
		}

		return $this;
	} 
	
	public function setObjectId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->object_id !== $v) {
			$this->object_id = $v;
			$this->modifiedColumns[] = RepozytoriumModulMapPeer::OBJECT_ID;
		}

		return $this;
	} 
	
	public function hasOnlyDefaultValues()
	{
						if (array_diff($this->modifiedColumns, array())) {
				return false;
			}

				return true;
	} 
	
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->repozytorium_id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->modul_id = ($row[$startcol + 1] !== null) ? (int) $row[$startcol + 1] : null;
			$this->object_id = ($row[$startcol + 2] !== null) ? (int) $row[$startcol + 2] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

						return $startcol + 3; 
		} catch (Exception $e) {
			throw new PropelException("Error populating RepozytoriumModulMap object", $e);
		}
	}

	
	public function ensureConsistency()
	{

		if ($this->aRepozytorium !== null && $this->repozytorium_id !== $this->aRepozytorium->getId()) {
			$this->aRepozytorium = null;
		}
		if ($this->aModul !== null && $this->modul_id !== $this->aModul->getId()) {
			$this->aModul = null;
		}
	} 
	
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(RepozytoriumModulMapPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

				
		$stmt = RepozytoriumModulMapPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); 
		if ($deep) {  
			$this->aRepozytorium = null;
			$this->aModul = null;
		} 	}

	
	public function delete(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(RepozytoriumModulMapPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			RepozytoriumModulMapPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	public function save(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(RepozytoriumModulMapPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
			RepozytoriumModulMapPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

												
			if ($this->aRepozytorium !== null) {
				if ($this->aRepozytorium->isModified() || $this->aRepozytorium->isNew()) {
					$affectedRows += $this->aRepozytorium->save($con);
				}
				$this->setRepozytorium($this->aRepozytorium);
			}

			if ($this->aModul !== null) {
				if ($this->aModul->isModified() || $this->aModul->isNew()) {
					$affectedRows += $this->aModul->save($con);
				}
				$this->setModul($this->aModul);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = RepozytoriumModulMapPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setNew(false);
				} else {
					$affectedRows += RepozytoriumModulMapPeer::doUpdate($this, $con);
				}

				$this->resetModified(); 			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aRepozytorium !== null) {
				if (!$this->aRepozytorium->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aRepozytorium->getValidationFailures());
				}
			}

			if ($this->aModul !== null) {
				if (!$this->aModul->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aModul->getValidationFailures());
				}
			}


			if (($retval = RepozytoriumModulMapPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = RepozytoriumModulMapPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getRepozytoriumId();
				break;
			case 1:
				return $this->getModulId();
				break;
			case 2:
				return $this->getObjectId();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = RepozytoriumModulMapPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getRepozytoriumId(),
			$keys[1] => $this->getModulId(),
			$keys[2] => $this->getObjectId(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = RepozytoriumModulMapPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setRepozytoriumId($value);
				break;
			case 1:
				$this->setModulId($value);
				break;
			case 2:
				$this->setObjectId($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = RepozytoriumModulMapPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setRepozytoriumId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setModulId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setObjectId($arr[$keys[2]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(RepozytoriumModulMapPeer::DATABASE_NAME);

		if ($this->isColumnModified(RepozytoriumModulMapPeer::REPOZYTORIUM_ID)) $criteria->add(RepozytoriumModulMapPeer::REPOZYTORIUM_ID, $this->repozytorium_id);
		if ($this->isColumnModified(RepozytoriumModulMapPeer::MODUL_ID)) $criteria->add(RepozytoriumModulMapPeer::MODUL_ID, $this->modul_id);
		if ($this->isColumnModified(RepozytoriumModulMapPeer::OBJECT_ID)) $criteria->add(RepozytoriumModulMapPeer::OBJECT_ID, $this->object_id);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(RepozytoriumModulMapPeer::DATABASE_NAME);

		$criteria->add(RepozytoriumModulMapPeer::REPOZYTORIUM_ID, $this->repozytorium_id);
		$criteria->add(RepozytoriumModulMapPeer::MODUL_ID, $this->modul_id);
		$criteria->add(RepozytoriumModulMapPeer::OBJECT_ID, $this->object_id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		$pks = array();

		$pks[0] = $this->getRepozytoriumId();

		$pks[1] = $this->getModulId();

		$pks[2] = $this->getObjectId();

		return $pks;
	}

	
	public function setPrimaryKey($keys)
	{

		$this->setRepozytoriumId($keys[0]);

		$this->setModulId($keys[1]);

		$this->setObjectId($keys[2]);

	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setRepozytoriumId($this->repozytorium_id);

		$copyObj->setModulId($this->modul_id);

		$copyObj->setObjectId($this->object_id);


		$copyObj->setNew(true);

	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new RepozytoriumModulMapPeer();
		}
		return self::$peer;
	}

	
	public function setRepozytorium(Repozytorium $v = null)
	{
		if ($v === null) {
			$this->setRepozytoriumId(NULL);
		} else {
			$this->setRepozytoriumId($v->getId());
		}

		$this->aRepozytorium = $v;

						if ($v !== null) {
			$v->addRepozytoriumModulMap($this);
		}

		return $this;
	}


	
	public function getRepozytorium(PropelPDO $con = null)
	{
		if ($this->aRepozytorium === null && ($this->repozytorium_id !== null)) {
			$c = new Criteria(RepozytoriumPeer::DATABASE_NAME);
			$c->add(RepozytoriumPeer::ID, $this->repozytorium_id);
			$this->aRepozytorium = RepozytoriumPeer::doSelectOne($c, $con);
			
		}
		return $this->aRepozytorium;
	}

	
	public function setModul(Modul $v = null)
	{
		if ($v === null) {
			$this->setModulId(NULL);
		} else {
			$this->setModulId($v->getId());
		}

		$this->aModul = $v;

						if ($v !== null) {
			$v->addRepozytoriumModulMap($this);
		}

		return $this;
	}


	
	public function getModul(PropelPDO $con = null)
	{
		if ($this->aModul === null && ($this->modul_id !== null)) {
			$c = new Criteria(ModulPeer::DATABASE_NAME);
			$c->add(ModulPeer::ID, $this->modul_id);
			$this->aModul = ModulPeer::doSelectOne($c, $con);
			
		}
		return $this->aModul;
	}

	
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
		} 
			$this->aRepozytorium = null;
			$this->aModul = null;
	}

} 